       function Check_Oneway (Current, Previous: sector): boolean;
       var Oneway: boolean;
           Warps, index: integer;
           NextUp: sector;
       begin
       Warps := space.sectors[current].number;
       OneWay := true;         { assume Oneway for now }
       for Index := 1 to Warps do
         begin
         NextUp := space.sectors[current].data[Index];
         if NextUp = previous then   { Not Oneway }
           OneWay := false;
         end;
       Check_Oneway := Oneway;
       end;

    procedure GoToEnd (var current, previous: Sector; var Length: integer);
    var
      NextUp, Start: Sector;
      Warps, Index, Baselength: integer;
      OneWay: boolean;
    begin
    Baselength := length;
    Warps := space.sectors[current].number;
    if Warps > 0 then
      begin
      Oneway := Check_Oneway (current, previous);
      if OneWay then            { this route is not an enterance }
        begin
        Warps := 1;
        current := previous;
        end;
      end
    else
      length := length + 8;
    while (warps = 2) do   { Keep going through tunnel }
      begin
      NextUp := space.sectors[current].data[1];
      if NextUp = previous then
        NextUp := space.sectors[current].data[2];
      previous := current;
      current := nextUp;
      Length := Length + 1;
      Warps := space.sectors[current].number;
          { Check if a one way warp has been used }
      if Warps > 0 then
        begin
        Oneway := Check_Oneway (current, previous);
        if OneWay then
          begin
          Warps := 1;   { as good as a dead end }
          length := baselength;
          current := previous;
          end;
        end
      else
        length := length + 8;
      end; { while warps = 2 }
    end;   { Current is the first sector without 1 warp in and 1 out }

      function CloseBottom (Current, Previous: Sector;
                            Maxdepth, BaseDepth: integer): boolean;
      var
        WhichPath, Depth, Warps, Index: integer;
        Status, Oneway: boolean;
        NextUp: sector;
      begin
      Status := true;    { assume closebottom }
      Depth := BaseDepth;  { BaseDepth is greater than one only
                             when this function calls itself recursively }
      GoToEnd (current, previous, Depth);
         { seek a dead end, a branch path or one way (return as current) }
      if MaxDepth >= Depth then
        begin
        Warps := space.sectors[current].number;
        case Warps of
          0: Status := false;  { Unexplored Sector }
          1: Status := true    { Dead end or one way exit }
          else
            begin
            Oneway := Check_Oneway (current, previous);
            if not OneWay then   { Oneway are closebottoms automatically }
              for WhichPath := 1 to Warps do   { Check all exits for
                                                 closebottoms }
                begin
                NextUp := space.sectors[current].data[WhichPath];
                if NextUp <> previous then
                  Status := Status and
                    CloseBottom (NextUp, Current, MaxDepth, Depth + 1)
                  { if any exit does not have a close bottom
                    Status will be false  }
              end; { if not oneway / for whichpath = }
            end; { else }
          end; {case Warps}
        CloseBottom := Status;
        end  { if MaxDepth => Depth }
      else
        CloseBottom := false;
      end;   { function CloseBottom }

  function BottleNeck (base, previous: Sector;
                       MaxDepth: integer): Sector;
  { Check to see if there is only one exit from the current Sector
    and if so the exit will be BottleNeck. This is done by following each
    warp to see if it dead ends at a point equal or closer than the
    base sector is to the current sector. }
  var
    WhichPath, Exits, Warps: integer;
    Current, NewNeck: sector;
  begin
  Exits := 0;
  Warps := space.sectors[base].number;
  if Warps = 0 then
    BottleNeck := Base
  else
    begin
    for WhichPath := 1 to Warps do
      begin
      Current := space.sectors[base].data[WhichPath];   { Next Exit Sector }
      if Current <> previous then   { Not back to base sector }
        begin
        if not CloseBottom (Current, Base , MaxDepth, 1) then
               { i.e. there is an exit longer the original (Maxdepth) }
          begin
          NewNeck := current;  { If this is the only exit, than it is
                                 a new bottleneck sector }
          Exits := Exits + 1;
          end;  { if not closebottom }
        end;  { if not back to original dead end }
      end;  { for whichpath = (try each exit) }
    if Exits = 1 then
      BottleNeck := NewNeck
    else
      BottleNeck := Base;
    end;
  end;

function HowDeep( base : sector; var Neck: sector ) : integer;
{ return length of path from furthest sector "Neck" that
  is the only enterance to base sector }
var
  previous, current, LastNeck: sector;
  len: integer;
begin
previous := base;
current := space.sectors[base].data[1];  { only one exit initially }
len := 0;
GoToEnd(current, previous, len); {Go to a Sector that does not have 2 warps
                                  ** or is a one way}
Neck := current;  { First BottleNeck at this sector:
                    The last sector that must be used to enter the
                    base sector }
repeat
  LastNeck := Neck;
  len := len + 1;
  Neck := BottleNeck (Neck, previous, len);   { Check for more Bottlenecks}
  previous := LastNeck;
until (Neck = LastNeck) or (len > 12);
HowDeep := len;
end;
